Fixed bug in basictest to delete instances complex3 and complex4
[osm/RO.git] / test / basictest.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openmano
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #This script can be used as a basic test of openmano.
25 #WARNING: It destroy the database content
26
27
28 function usage(){
29 echo -e "usage: ${BASH_SOURCE[0]} [OPTIONS] <action>\n test openmano using openvim as a VIM"
30 echo -e " the OPENVIM_HOST, OPENVIM_PORT shell variables indicate openvim location"
31 echo -e " by default localhost:9080"
32 echo -e " <action> is a list of the following items (by default 'reset create delete')"
33 echo -e " reset reset the openmano database content"
34 echo -e " create creates items"
35 echo -e " delete delete created items"
36 echo -e " OPTIONS:"
37 echo -e " -f --force does not prompt for confirmation"
38 echo -e " -h --help shows this help"
39 echo -e " --insert-bashrc insert the created tenant,datacenter variables at"
40 echo -e " ~/.bashrc to be available by openmano CLI"
41 echo -e " --init-openvim if openvim runs locally, an init is called to clean openvim"
42 echo -e " database and add fake hosts"
43 }
44
45 function is_valid_uuid(){
46 echo "$1" | grep -q -E '^[0-9a-f]{8}-([0-9a-f]{4}-){3}[0-9a-f]{12}$' && return 0
47 return 1
48 }
49
50 #detect if is called with a source to use the 'exit'/'return' command for exiting
51 [[ ${BASH_SOURCE[0]} != $0 ]] && _exit="return" || _exit="exit"
52
53
54 #check correct arguments
55 force=""
56 action_list=""
57 insert_bashrc=""
58 init_openvim=""
59
60 while [[ $# -gt 0 ]]
61 do
62 argument="$1"
63 shift
64 if [[ $argument == reset ]] || [[ $argument == create ]] || [[ $argument == delete ]]
65 then
66 action_list="$action_list $argument"
67 continue
68 #short options
69 elif [[ ${argument:0:1} == "-" ]] && [[ ${argument:1:1} != "-" ]] && [[ ${#argument} -ge 2 ]]
70 then
71 index=0
72 while index=$((index+1)) && [[ $index -lt ${#argument} ]]
73 do
74 [[ ${argument:$index:1} == h ]] && usage && $_exit 0
75 [[ ${argument:$index:1} == f ]] && force="-f" && continue
76 echo "invalid option '${argument:$index:1}'? Type -h for help" >&2 && $_exit 1
77 done
78 continue
79 fi
80 #long options
81 [[ $argument == --help ]] && usage && $_exit 0
82 [[ $argument == --force ]] && force="-f" && continue
83 [[ $argument == --insert-bashrc ]] && insert_bashrc="--insert-bashrc" && continue
84 [[ $argument == --init-openvim ]] && init_openvim="y" && continue
85 echo "invalid argument '$argument'? Type -h for help" >&2 && $_exit 1
86 done
87
88 DIRNAME=$(dirname $(readlink -f ${BASH_SOURCE[0]}))
89 DIRmano=$(dirname $DIRNAME)
90 DIRscript=${DIRmano}/scripts
91 export OPENMANO_HOST=localhost
92 export OPENMANO_PORT=9090
93 [[ -n "$insert_bashrc" ]] && echo -e "\nexport OPENMANO_HOST=localhost" >> ~/.bashrc
94 [[ -n "$insert_bashrc" ]] && echo -e "\nexport OPENMANO_PORT=9090" >> ~/.bashrc
95
96
97 #by default action should be reset and create
98 [[ -z $action_list ]] && action_list="reset create delete"
99 [[ -z $init_openvim ]] || initopenvim $force $insert_bashrc || echo "WARNING openvim cannot be initialized. The rest of test can fail!"
100
101 #check openvim client variables are set
102 #fail=""
103 #[[ -z $OPENVIM_HOST ]] && echo "OPENVIM_HOST variable not defined" >&2 && fail=1
104 #[[ -z $OPENVIM_PORT ]] && echo "OPENVIM_PORT variable not defined" >&2 && fail=1
105 #[[ -n $fail ]] && $_exit 1
106
107
108 for action in $action_list
109 do
110 #if [[ $action == "install-openvim" ]]
111 #echo "Installing and starting openvim"
112 #mkdir -p temp
113 #pushd temp
114 #wget https://github.com/nfvlabs/openvim/raw/v0.4/scripts/install-openvim.sh
115 #chmod -x install-openvim.sh
116 #fi
117
118 if [[ $action == "reset" ]]
119 then
120
121 #ask for confirmation if argument is not -f --force
122 force_=y
123 [[ -z $force ]] && read -e -p "WARNING: reset openmano database, content will be lost!!! Continue(y/N) " force_
124 [[ $force_ != y ]] && [[ $force_ != yes ]] && echo "aborted!" && $_exit
125
126 echo "Stopping openmano"
127 $DIRscript/service-openmano.sh mano stop
128 echo "Initializing openmano database"
129 $DIRmano/database_utils/init_mano_db.sh -u mano -p manopw --createdb
130 echo "Starting openmano"
131 $DIRscript/service-openmano.sh mano start
132 echo
133
134 elif [[ $action == "delete" ]]
135 then
136 result=`openmano tenant-list TEST-tenant`
137 nfvotenant=`echo $result |gawk '{print $1}'`
138 #check a valid uuid is obtained
139 is_valid_uuid $nfvotenant || ! echo "Tenant TEST-tenant not found. Already delete?" >&2 || $_exit 1
140 export OPENMANO_TENANT=$nfvotenant
141 ${DIRmano}/openmano instance-scenario-delete -f simple-instance || echo "fail"
142 ${DIRmano}/openmano instance-scenario-delete -f complex-instance || echo "fail"
143 ${DIRmano}/openmano instance-scenario-delete -f complex2-instance || echo "fail"
144 ${DIRmano}/openmano instance-scenario-delete -f complex3-instance || echo "fail"
145 ${DIRmano}/openmano instance-scenario-delete -f complex4-instance || echo "fail"
146 ${DIRmano}/openmano scenario-delete -f simple || echo "fail"
147 ${DIRmano}/openmano scenario-delete -f complex || echo "fail"
148 ${DIRmano}/openmano scenario-delete -f complex2 || echo "fail"
149 ${DIRmano}/openmano scenario-delete -f complex3 || echo "fail"
150 ${DIRmano}/openmano scenario-delete -f complex4 || echo "fail"
151 ${DIRmano}/openmano vnf-delete -f linux || echo "fail"
152 ${DIRmano}/openmano vnf-delete -f linux_2VMs_v02 || echo "fail"
153 ${DIRmano}/openmano vnf-delete -f dataplaneVNF_2VMs || echo "fail"
154 ${DIRmano}/openmano vnf-delete -f dataplaneVNF_2VMs_v02 || echo "fail"
155 ${DIRmano}/openmano vnf-delete -f dataplaneVNF2 || echo "fail"
156 ${DIRmano}/openmano vnf-delete -f dataplaneVNF3 || echo "fail"
157 ${DIRmano}/openmano datacenter-detach TEST-dc || echo "fail"
158 ${DIRmano}/openmano datacenter-delete -f TEST-dc || echo "fail"
159 ${DIRmano}/openmano tenant-delete -f TEST-tenant || echo "fail"
160 echo
161
162 elif [[ $action == "create" ]]
163 then
164 printf "%-50s" "Creating openmano tenant 'TEST-tenant': "
165 result=`${DIRmano}/openmano tenant-create TEST-tenant --description="created by basictest.sh"`
166 nfvotenant=`echo $result |gawk '{print $1}'`
167 #check a valid uuid is obtained
168 ! is_valid_uuid $nfvotenant && echo "FAIL" && echo " $result" && $_exit 1
169 export OPENMANO_TENANT=$nfvotenant
170 [[ -n "$insert_bashrc" ]] && echo -e "\nexport OPENMANO_TENANT=$nfvotenant" >> ~/.bashrc
171 echo $nfvotenant
172
173 printf "%-50s" "Creating datacenter 'TEST-dc' in openmano:"
174 [[ -z $OPENVIM_HOST ]] && OPENVIM_HOST=localhost
175 [[ -z $OPENVIM_PORT ]] && OPENVIM_PORT=9080
176 URL_ADMIN_PARAM=""
177 [[ -n $OPENVIM_ADMIN_PORT ]] && URL_ADMIN_PARAM="--url_admin=http://${$OPENVIM_HOST}:${OPENVIM_ADMIN_PORT}/openvim"
178 result=`${DIRmano}/openmano datacenter-create TEST-dc "http://${OPENVIM_HOST}:${OPENVIM_PORT}/openvim" --type=openvim $URL_ADMIN_PARAM`
179 datacenter=`echo $result |gawk '{print $1}'`
180 #check a valid uuid is obtained
181 ! is_valid_uuid $datacenter && echo "FAIL" && echo " $result" && $_exit 1
182 echo $datacenter
183 export OPENMANO_DATACENTER=$datacenter
184 [[ -n "$insert_bashrc" ]] && echo -e "\nexport OPENMANO_DATACENTER=$datacenter" >> ~/.bashrc
185
186 printf "%-50s" "Attaching openmano tenant to the datacenter:"
187 result=`${DIRmano}/openmano datacenter-attach TEST-dc`
188 [[ $? != 0 ]] && echo "FAIL" && echo " $result" && $_exit 1
189 echo OK
190
191 printf "%-50s" "Updating external nets in openmano: "
192 result=`${DIRmano}/openmano datacenter-netmap-delete -f --all`
193 [[ $? != 0 ]] && echo "FAIL" && echo " $result" && $_exit 1
194 result=`${DIRmano}/openmano datacenter-netmap-import -f`
195 [[ $? != 0 ]] && echo "FAIL" && echo " $result" && $_exit 1
196 echo OK
197
198 for VNF in linux dataplaneVNF1 dataplaneVNF2 dataplaneVNF_2VMs dataplaneVNF_2VMs_v02 dataplaneVNF3 linux_2VMs_v02
199 do
200 printf "%-50s" "Creating VNF '${VNF}': "
201 result=`$DIRmano/openmano vnf-create $DIRmano/vnfs/examples/${VNF}.yaml`
202 vnf=`echo $result |gawk '{print $1}'`
203 #check a valid uuid is obtained
204 ! is_valid_uuid $vnf && echo FAIL && echo " $result" && $_exit 1
205 echo $vnf
206 done
207 for NS in simple complex complex2 complex3 complex4
208 do
209 printf "%-50s" "Creating scenario '${NS}':"
210 result=`$DIRmano/openmano scenario-create $DIRmano/scenarios/examples/${NS}.yaml`
211 scenario=`echo $result |gawk '{print $1}'`
212 ! is_valid_uuid $scenario && echo FAIL && echo " $result" && $_exit 1
213 echo $scenario
214 done
215
216 for IS in simple complex complex2 complex3
217 do
218 printf "%-50s" "Creating instance-scenario '${IS}':"
219 result=`$DIRmano/openmano instance-scenario-create --scenario ${IS} --name ${IS}-instance`
220 instance=`echo $result |gawk '{print $1}'`
221 ! is_valid_uuid $instance && echo FAIL && echo " $result" && $_exit 1
222 echo $instance
223 done
224
225 printf "%-50s" "Creating instance-scenario 'complex4':"
226 result=`$DIRmano/openmano instance-scenario-create $DIRmano/instance-scenarios/examples/instance-creation-complex4.yaml`
227 instance=`echo $result |gawk '{print $1}'`
228 ! is_valid_uuid $instance && echo FAIL && echo " $result" && $_exit 1
229 echo $instance
230
231 echo
232 #echo "Check virtual machines are deployed"
233 #vms_error=`openvim vm-list | grep ERROR | wc -l`
234 #vms=`openvim vm-list | wc -l`
235 #[[ $vms -ne 8 ]] && echo "WARNING: $vms VMs created, must be 8 VMs" >&2 && $_exit 1
236 #[[ $vms_error -gt 0 ]] && echo "WARNING: $vms_error VMs with ERROR" >&2 && $_exit 1
237 fi
238 done
239
240 echo
241 echo DONE
242
243